//--------------------------------------------------------------------------//
// xmtnimage67.cc                                                           //
// Latest revision: 10-05-2006                                              //
// Copyright (C) 2003 by Thomas J. Nelson                                   //
// See xmtnimage.h for Copyright Notice                                     //
//--------------------------------------------------------------------------//

#include "xmtnimage.h"

extern int         ci;                 // current image
extern Image      *z;
extern Globals     g;
static double ca_answers[10][3]={{0,  0,   0},     // 0
                                 {0,  0,   0},     // 1
                                 {0,  0,   0},     // 2 x shift
                                 {0,  0,   0},     // 3 y shift
                                 {1.0, 1.0, 1.0},  // 4 x linear stretch
                                 {1.0, 1.0, 1.0},  // 5 y linear stretch
                                 {1.0, 1.0, 1.0},  // 6 radial stretch
                                 {1.0, 1.0, 1.0},  // 7 radial stretch 2nd order
                                 {0,   0,   0},    // 8 sharpen  
                                 {0,   0,   0}     // 9 erode    
                                 };

static int enhance_want_filter = 1;
static int enhance_radius = 2;
static int enhance_lines = 0;


//--------------------------------------------------------------------------//
// chromaticaberration                                                      //
//--------------------------------------------------------------------------//
void chromaticaberration(void)
{
   g.getout=0;
   static Dialog *dialog;
   int j, k, ino;
   g.getout=0;
   ino = ci;
   if(ino<0) return;
   dialog = new Dialog;
   if(dialog==NULL){ message(g.nomemory); return; }
   g.inmenu++;  // no 'return's after this point

   //// Dialog

   strcpy(dialog->title,"Chromatic Aberration");

   strcpy(dialog->boxes[0],"");
   strcpy(dialog->boxes[1],"Color channel");
   strcpy(dialog->boxes[2],"x xhift");
   strcpy(dialog->boxes[3],"y shift");
   strcpy(dialog->boxes[4],"x linear stretch");
   strcpy(dialog->boxes[5],"y linear stretch");
   strcpy(dialog->boxes[6],"radial stretch");
   strcpy(dialog->boxes[7],"radial stretch 2nd order");
   strcpy(dialog->boxes[8],"Sharpen");
   strcpy(dialog->boxes[9],"Erode");

   dialog->boxtype[0]=LABEL;
   dialog->boxtype[1]=MULTILABEL; 
   for(k=2;k<=9;k++) dialog->boxtype[k]=MULTISTRING; 

   strcpy(dialog->answer[1][0], "Red");
   strcpy(dialog->answer[1][1], "Green");
   strcpy(dialog->answer[1][2], "Blue");
   for(j=2; j<10; j++)
   for(k=0; k<3; k++)
       sprintf(dialog->answer[j][k], "%g", ca_answers[j][k]);

   dialog->radiono[0]=0;
   for(j=0;j<10;j++){ for(k=0;k<20;k++) dialog->radiotype[j][k]=RADIO; }
   for(k=0;k<20;k++) dialog->wcount[k]=3;

   dialog->noofradios = 0;
   dialog->noofboxes  = 10;
   dialog->helptopic  = 1;  
   dialog->want_changecicb = 0;
   dialog->f1 = chromaticaberrationcheck;
   dialog->f2 = null;
   dialog->f3 = null;
   dialog->f4 = chromaticaberrationfinish;
   dialog->f5 = null;
   dialog->f6 = null;
   dialog->f7 = null;
   dialog->f8 = null;
   dialog->f9 = null;
   dialog->width = 0;  // calculate automatically
   dialog->height = 0; // calculate automatically
   strcpy(dialog->path,".");
   dialog->transient = 1;
   dialog->wantraise = 0;
   dialog->radiousexy = 0;
   dialog->boxusexy = 0;
   dialog->hit = 0;
   dialog->message[0] = 0;      
   dialog->busy = 0;
   dialogbox(dialog);
   g.inmenu--;
   return;
}


//--------------------------------------------------------------------------//
//  chromaticaberrationcheck                                                //
//--------------------------------------------------------------------------//
void chromaticaberrationcheck(dialoginfo *a, int radio, int box, int boxbutton)
{
   a = a;
   box=box; boxbutton=boxbutton; radio=radio;
   static filter *ff;
   static int hitff = 0;
   g.getout = 0;
   int j;
   int k,ino, owantr=g.wantr, owantg=g.wantg, owantb=g.wantb;
   ino = ci;
   if(!a->hit) for(k=0;k<3;k++) update_chromatic_aberration_dialog(a, k);
   if(!hitff)
   {    ff = new filter;
        ff->ino = ino;
        ff->type  = 1;
        ff->x1 = 0;
        ff->x2 = z[0].xsize-1;
        ff->y1 = 0;
        ff->y2 = z[0].ysize-1;
        ff->ksize = 3;
        ff->sharpfac = 0;  // user-adjustable param
        ff->range = 1;
        ff->kmult = 1;
        ff->maxbkg  = 1;
        ff->entireimage = 1;
        ff->diffsize = 1;
        ff->filename[0] = 0;
        ff->ithresh  = 0;
        ff->local_scale = 0;
        ff->want_progress_bar = 1;
        ff->do_filtering = 1;
        hitff=1;
    }

   if(between(box, 2, 9))  // User changed a number
   {   for(j=2; j<10; j++)
      {   ca_answers[j][0] = atof(a->answer[j][0]);
          ca_answers[j][1] = atof(a->answer[j][1]);
          ca_answers[j][2] = atof(a->answer[j][2]);
      }
   }
   if(radio==-2)         // OK key pressed
   {   //// h shift 
       g.wantr = 1; g.wantg = 0; g.wantb = 0;       
       if(ca_answers[2][0]) image_shift_frame(ino, cint(ca_answers[2][0]), 0);
       g.wantr = 0; g.wantg = 1; g.wantb = 0;       
       if(ca_answers[2][1]) image_shift_frame(ino, cint(ca_answers[2][1]), 0);
       g.wantr = 0; g.wantg = 0; g.wantb = 1;       
       if(ca_answers[2][2]) image_shift_frame(ino, cint(ca_answers[2][2]), 0);

       //// v shift
       g.wantr = 1; g.wantg = 0; g.wantb = 0;       
       if(ca_answers[3][0]) image_shift_frame(ino, 0, cint(ca_answers[3][0]));
       g.wantr = 0; g.wantg = 1; g.wantb = 0;       
       if(ca_answers[3][1]) image_shift_frame(ino, 0, cint(ca_answers[3][1]));
       g.wantr = 0; g.wantg = 0; g.wantb = 1;       
       if(ca_answers[3][2]) image_shift_frame(ino, 0, cint(ca_answers[3][2]));

       //// x linear stretch
       g.wantr = 1; g.wantg = 0; g.wantb = 0;       
       if(ca_answers[4][0]) shrink_image_interpolate_in_place(ino, ca_answers[4][0], 1.0);
       g.wantr = 0; g.wantg = 1; g.wantb = 0;       
       if(ca_answers[4][1]) shrink_image_interpolate_in_place(ino, ca_answers[4][1], 1.0);
       g.wantr = 0; g.wantg = 0; g.wantb = 1;       
       if(ca_answers[4][2]) shrink_image_interpolate_in_place(ino, ca_answers[4][2], 1.0);

       //// y linear stretch
       g.wantr = 1; g.wantg = 0; g.wantb = 0;       
       if(ca_answers[5][0]) shrink_image_interpolate_in_place(ino, 1.0, ca_answers[5][0]);
       g.wantr = 0; g.wantg = 1; g.wantb = 0;       
       if(ca_answers[5][1]) shrink_image_interpolate_in_place(ino, 1.0, ca_answers[5][1]);
       g.wantr = 0; g.wantg = 0; g.wantb = 1;       
       if(ca_answers[5][2]) shrink_image_interpolate_in_place(ino, 1.0, ca_answers[5][2]);

       //// radial stretch
       g.wantr = 1; g.wantg = 0; g.wantb = 0;       
       if(ca_answers[6][0]) shrink_image_interpolate_in_place(ino, 1.0, ca_answers[6][0]);
       if(ca_answers[6][0]) shrink_image_interpolate_in_place(ino, ca_answers[6][0], 1.0);
       g.wantr = 0; g.wantg = 1; g.wantb = 0;       
       if(ca_answers[6][1]) shrink_image_interpolate_in_place(ino, 1.0, ca_answers[6][1]);
       if(ca_answers[6][1]) shrink_image_interpolate_in_place(ino, ca_answers[6][1], 1.0);
       g.wantr = 0; g.wantg = 0; g.wantb = 1;       
       if(ca_answers[6][2]) shrink_image_interpolate_in_place(ino, 1.0, ca_answers[6][2]);
       if(ca_answers[6][2]) shrink_image_interpolate_in_place(ino, ca_answers[6][2], 1.0);

       ////  sharpen
       g.wantr = 1; g.wantg = 0; g.wantb = 0;       
       if(ca_answers[8][0]) { ff->sharpfac = cint(ca_answers[8][0]); filter_region(ff); }
       g.wantr = 0; g.wantg = 1; g.wantb = 0;       
       if(ca_answers[8][1]) { ff->sharpfac = cint(ca_answers[8][1]); filter_region(ff); }
       g.wantr = 0; g.wantg = 0; g.wantb = 1;       
       if(ca_answers[8][2]) { ff->sharpfac = cint(ca_answers[8][2]); filter_region(ff); }
       
       ////  erode
       g.wantr = 1; g.wantg = 0; g.wantb = 0;       
       if(ca_answers[9][0]) { dilate_erode_rgb(ino, 2, 1, 255, 0.01*ca_answers[9][0]); }
       g.wantr = 0; g.wantg = 1; g.wantb = 0;       
       if(ca_answers[9][1]) { dilate_erode_rgb(ino, 2, 1, 255, 0.01*ca_answers[9][1]); }
       g.wantr = 0; g.wantg = 0; g.wantb = 1;       
       if(ca_answers[9][2]) { dilate_erode_rgb(ino, 2, 1, 255, 0.01*ca_answers[9][2]); }

   }

 g.wantr = owantr; g.wantg = owantg; g.wantb = owantb;       
 return;
}


//--------------------------------------------------------------------------//
//  chromaticaberrationfinish                                               //
//--------------------------------------------------------------------------//
void chromaticaberrationfinish(dialoginfo *a)
{
   int j,k;
   for(j=2; j<10; j++)
   for(k=0; k<3; k++)
       ca_answers[j][k] = atof(a->answer[j][k]);
}

//-------------------------------------------------------------------------//
// update_chromatic_aberration_dialog                                      //
//-------------------------------------------------------------------------//
void update_chromatic_aberration_dialog(Dialog *a, int color)
{  
   Widget w;
   int j,k;
   XmTextPosition curpos;
   a->hit = 1;
   k = color;
   for(j=2; j<10; j++)
   {    //// Get rid of callback or it will go into a loop
        w = a->boxwidget[j][k];
        XtRemoveCallback(w, XmNvalueChangedCallback, 
            (XtCBP)dialogstringcb, (XtP)a);
        XtVaGetValues(w, XmNcursorPosition, &curpos, NULL);
        XtVaSetValues(w, XmNvalue, a->answer[j][k], 
                         XmNcursorPosition, curpos, 
                         NULL); 
        XtAddCallback(a->boxwidget[j][k], XmNvalueChangedCallback, 
            (XtCBP)dialogstringcb, (XtP)a);
       sprintf(a->answer[j][k], "%g", ca_answers[j][k]);
   }
}


//-------------------------------------------------------------------------//
// enhance_spots                                                           //
// Make small spots darker, background flat. Needs optimization.           //
//-------------------------------------------------------------------------//
void enhance_spots(void)
{   
   g.getout=0;
   static Dialog *dialog;
   int j, k, ino;
   g.getout=0;
   ino = ci;
   if(ino<0) return;
   dialog = new Dialog;
   if(dialog==NULL){ message(g.nomemory); return; }
   g.inmenu++;  // no 'return's after this point

   //// Dialog

   strcpy(dialog->title,"Enhance spots");

   strcpy(dialog->boxes[0],"Parameters");
   dialog->boxtype[0]=LABEL;

   strcpy(dialog->boxes[1],"Use contrast filter");
   dialog->boxtype[1]=TOGGLE; 
   dialog->boxset[1] = enhance_want_filter;

   strcpy(dialog->boxes[2],"De-emphasize lines");
   dialog->boxtype[2]=TOGGLE; 
   dialog->boxset[2] = enhance_lines;

   strcpy(dialog->boxes[3],"Maximum spot radius");
   dialog->boxtype[3]=INTCLICKBOX;
   dialog->boxmin[3]=1; dialog->boxmax[3] = 20;
   sprintf(dialog->answer[3][0], "%d", enhance_radius);

   dialog->radiono[0]=0;
   for(j=0;j<10;j++){ for(k=0;k<20;k++) dialog->radiotype[j][k]=RADIO; }
   for(k=0;k<20;k++) dialog->wcount[k]=3;

   dialog->noofradios = 0;
   dialog->noofboxes  = 4;
   dialog->helptopic  = 76;  
   dialog->want_changecicb = 0;
   dialog->f1 = enhance_spots_check;
   dialog->f2 = null;
   dialog->f3 = null;
   dialog->f4 = enhance_spots_finish;
   dialog->f5 = null;
   dialog->f6 = null;
   dialog->f7 = null;
   dialog->f8 = null;
   dialog->f9 = null;
   dialog->width = 0;  // calculate automatically
   dialog->height = 0; // calculate automatically
   strcpy(dialog->path,".");
   dialog->transient = 1;
   dialog->wantraise = 0;
   dialog->radiousexy = 0;
   dialog->boxusexy = 0;
   dialog->hit = 0;
   dialog->message[0] = 0;      
   dialog->busy = 0;
   dialogbox(dialog);
   g.inmenu--;
   return;
}

//-------------------------------------------------------------------------//
// enhance_spots_cancel                                                    //
//-------------------------------------------------------------------------//
void enhance_spots_cancel(dialoginfo *a)
{
   a=a;
   g.getout = 1;
}


//-------------------------------------------------------------------------//
// enhance_spots_finish                                                    //
//-------------------------------------------------------------------------//
void enhance_spots_finish(dialoginfo *a)
{
   a=a;
   g.getout = 1;
}


//-------------------------------------------------------------------------//
// enhance_spots_check                                                     //
//-------------------------------------------------------------------------//
void enhance_spots_check(dialoginfo *dialog, int radio, int box, int boxbutton)
{
   int radius = 2; // if changed, resize lowest[] and highest[]
   radio=radio; box=box; boxbutton=boxbutton;
   uint v1, v2;
   double d;
   Widget www, scrollbar;
   int color,dist,f,i,j,ii,ii2,jj,i2,ino,newino,r;
   int score = 0;                       // low score = in a spot
   int xsize = z[ci].xsize;
   int ysize = z[ci].ysize;
   int bpp = z[ci].bpp;
   int cf = z[ci].cf;
   int b = g.off[bpp];                  // size of pixel in bytes
   int frames = z[ci].frames;   
   // can't use variables here in some compilers
   int lowest[4];    // must be radius * 2
   int highest[4];   // must be radius * 2
   int maxval = int(g.maxvalue[bpp]);
   int fparams[12] = {0, 0, 50, 0, 1, 0, 0, 0, 10, 0, 0, 0};
   ino = ci;
   char defaultfilename[64];
   strcpy(defaultfilename, "Image"); // keep compiler quiet
   
   //// find out params from dialog box
   if(radio != -2) return;   //// If user clicked Ok or Enter, continue rotating
   if(g.getout) return;
   enhance_want_filter = dialog->boxset[1];
   enhance_radius = atoi(dialog->answer[3][0]);
   if(z[ino].colortype != GRAY) {message("Image must be grayscale"); return;}
   

   //// start doing stuff
   if(enhance_want_filter) image_filter(16, fparams);
   radius = enhance_radius;

   //// create 8-bit image for result
   if(newimage(defaultfilename,0,0,xsize,ysize,8,GRAY,frames,0,1,PERM,1,0,0)!=OK){ message(g.nomemory, ERROR); return;}
   newino = ci;
   f = 0;

   progress_bar_open(www, scrollbar);
   
   for(j=0; j<ysize; j++)
   {   progress_bar_update(scrollbar, j*100/ysize);
       if(g.getout) break;
       for(i=0,i2=0; i<xsize; i++,i2+=b)  // loop over pixels in image
       {   
            v1 = maxval - pixelat(z[ino].image[cf][j]+i2, bpp);
            for(r=0; r<=radius; r++)                   // initialize arrays
            {   lowest[r] = maxval;
                highest[r] = 0;
            }

            for(jj=j-radius; jj<j+radius; jj++)       // search 10x10 pixels around each pixel
            {   if(jj<0 || jj>=ysize) continue;
                for(ii=i-radius,ii2=b*(i-radius); ii<i+radius; ii++,ii2+=b)
                {   if(ii<0 || ii>=xsize) continue;
                    v2 = 0;
                    v2 = pixelat(z[ino].image[cf][jj]+ii2, bpp);
                    d = sqrt((i-ii)*(i-ii) + (j-jj)*(j-jj));
                    dist = cint(d);    
                    if(dist > radius) continue;
                    if(v2<(uint)lowest[dist]) lowest[dist] = v2;
                    if(v2>(uint)highest[dist]) highest[dist] = v2;
                }
            }  

            score = 0;
            for(r=1; r<radius; r++)                   // calculate if pixel is in a spot
            {
                  score += r*v1*abs(highest[r] - lowest[r]) / 25;              

//                set r=5 to make zebra pattern
//                score += (r-1)*(r-1)*abs(highest[r] / max(1,lowest[r]))*255*255*255*255 ;              
            }
            
            if(bpp==16) score /= 65536;
            score = min(score, 255);
            color = 255 - score;
            color = max(0,min(255,color));
            z[newino].image[0][j][i] = color;      
       }
   }
   progress_bar_close(www);
   rebuild_display(newino);
   redraw(newino);
   moveimage(newino, 0, 0);
   z[newino].touched = 1;
   if(g.autoundo) backupimage(newino, 0);

}
